'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _rcSelect = require('rc-select');

var _rcSelect2 = _interopRequireDefault(_rcSelect);

var _utils = require('../utils');

var _rcEditorUtils = require('rc-editor-utils');

var _rcEditorUtils2 = _interopRequireDefault(_rcEditorUtils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj["default"] = obj; return newObj; } }

var getCurrentInlineStyle = _rcEditorUtils2["default"].getCurrentInlineStyle;
var getCurrentEntity = _rcEditorUtils2["default"].getCurrentEntity;

var Option = _rcSelect2["default"].Option;
var colorArray = ['c00000', 'ff0000', 'ffc000', 'ffff00', '92d050', '00b050', '00b0f0', '0070c0', '002060', '7030a0'];
var PREFIX = 'FONTCOLOR_';
var fontColor = {
    constructor: function constructor(config) {
        var callbacks = {
            getEditorState: _utils.noop,
            setEditorState: _utils.noop
        };
        var toggleStyle = (0, _utils.getToggleFontStyleFunc)(PREFIX, callbacks);
        function changeSelect(fontSize) {
            toggleStyle('' + PREFIX + fontSize);
        }
        function customStyleFn(styleSet) {
            return styleSet.map(function (style) {
                if (style.indexOf(PREFIX) !== -1) {
                    var color = '#' + style.substring(PREFIX.length);
                    return {
                        color: color
                    };
                }
                return {};
            }).reduce(Object.assign);
        }
        return {
            name: 'fontColor',
            callbacks: callbacks,
            customStyleFn: customStyleFn,
            component: function component(props) {
                var editorState = callbacks.getEditorState();
                var currentStyle = getCurrentInlineStyle(editorState);
                var currentFontSize = currentStyle.find(function (item) {
                    return item.indexOf('' + PREFIX) !== -1;
                });
                var fontColor = currentFontSize ? currentFontSize.substring(PREFIX.length) : '';
                console.log('>> fontColor', fontColor);
                var options = colorArray.map(function (item) {
                    return React.createElement(
                        Option,
                        { key: item, value: item, style: { backgroundColor: '#' + item } },
                        ' '
                    );
                });
                return React.createElement(
                    _rcSelect2["default"],
                    { prefixCls: config.prefixCls + '-select', onChange: changeSelect, style: { width: 80 }, value: fontColor },
                    options
                );
            }
        };
    }
};
exports["default"] = fontColor;
module.exports = exports['default'];